import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Domain, DomainParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询网站域名
 */
export async function pageDomain(params: DomainParam) {
  const res = await request.get<ApiResult<PageResult<Domain>>>(
    MODULES_API_URL + '/cms/domain/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询网站域名列表
 */
export async function listDomain(params?: DomainParam) {
  const res = await request.get<ApiResult<Domain[]>>(
    MODULES_API_URL + '/cms/domain',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加网站域名
 */
export async function addDomain(data: Domain) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/domain',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改网站域名
 */
export async function updateDomain(data: Domain) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/domain',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除网站域名
 */
export async function removeDomain(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/domain/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除网站域名
 */
export async function removeBatchDomain(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/domain/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户状态
 */
export async function updateDomainStatus(docsId?: number, status?: number) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/domain/status',
    {
      docsId,
      status
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询网站域名
 */
export async function getDomain(id: number) {
  const res = await request.get<ApiResult<Domain>>(
    MODULES_API_URL + '/cms/domain/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/domain/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

export async function resolvable(id: number) {
  const res = await request.get<ApiResult<Domain>>(
    MODULES_API_URL + '/cms/domain/resolvable/' + id
  );
  if (res.data.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}
